# Rust API client for apileague

API League is a Hub for World Class APIs.


## Overview

This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [openapi-spec](https://openapis.org) from a remote server, you can easily generate an API client.

- API version: 1.6.4
- Package version: 1.6.4
- Generator version: 7.8.0-SNAPSHOT
- Build package: `org.openapitools.codegen.languages.RustClientCodegen`

## Installation

Put the package under your project folder in a directory named `apileague` and add the following to `Cargo.toml` under `[dependencies]`:

```
apileague = { path = "./apileague" }
```

## Documentation for API Endpoints

All URIs are relative to *https://api.apileague.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ArtApi* | [**image_to_ascii_art_by_urlapi**](docs/ArtApi.md#image_to_ascii_art_by_urlapi) | **GET** /convert-image-to-ascii-txt | Image to Ascii Art by URL API
*ArtApi* | [**random_poem_api**](docs/ArtApi.md#random_poem_api) | **GET** /retrieve-random-poem | Random Poem API
*BooksApi* | [**find_similar_books_api**](docs/BooksApi.md#find_similar_books_api) | **GET** /list-similar-books | Find Similar Books API
*BooksApi* | [**search_books_api**](docs/BooksApi.md#search_books_api) | **GET** /search-books | Search Books API
*FoodApi* | [**compute_nutrition_api**](docs/FoodApi.md#compute_nutrition_api) | **GET** /compute-nutrition | Compute Nutrition API
*FoodApi* | [**retrieve_recipe_information_api**](docs/FoodApi.md#retrieve_recipe_information_api) | **GET** /retrieve-recipe | Retrieve Recipe Information API
*FoodApi* | [**search_drinks_api**](docs/FoodApi.md#search_drinks_api) | **GET** /search-drinks | Search Drinks API
*FoodApi* | [**search_recipes_api**](docs/FoodApi.md#search_recipes_api) | **GET** /search-recipes | Search Recipes API
*FoodApi* | [**search_restaurants_api**](docs/FoodApi.md#search_restaurants_api) | **GET** /search-restaurants | Search Restaurants API
*HumorApi* | [**generate_nonsense_word_api**](docs/HumorApi.md#generate_nonsense_word_api) | **GET** /generate-nonsense-word | Generate Nonsense Word API
*HumorApi* | [**random_joke_api**](docs/HumorApi.md#random_joke_api) | **GET** /retrieve-random-joke | Random Joke API
*HumorApi* | [**random_meme_api**](docs/HumorApi.md#random_meme_api) | **GET** /retrieve-random-meme | Random Meme API
*HumorApi* | [**search_gifs_api**](docs/HumorApi.md#search_gifs_api) | **GET** /search-gifs | Search Gifs API
*HumorApi* | [**search_jokes_api**](docs/HumorApi.md#search_jokes_api) | **GET** /search-jokes | Search Jokes API
*HumorApi* | [**search_memes_api**](docs/HumorApi.md#search_memes_api) | **GET** /search-memes | Search Memes API
*KnowledgeApi* | [**random_quote_api**](docs/KnowledgeApi.md#random_quote_api) | **GET** /retrieve-random-quote | Random Quote API
*KnowledgeApi* | [**random_riddle_api**](docs/KnowledgeApi.md#random_riddle_api) | **GET** /retrieve-random-riddle | Random Riddle API
*KnowledgeApi* | [**random_trivia_api**](docs/KnowledgeApi.md#random_trivia_api) | **GET** /retrieve-random-trivia | Random Trivia API
*MathApi* | [**convert_units_api**](docs/MathApi.md#convert_units_api) | **GET** /convert-units | Convert Units API
*MediaApi* | [**detect_main_image_color_api**](docs/MediaApi.md#detect_main_image_color_api) | **GET** /detect-color | Detect Main Image Color API
*MediaApi* | [**rescale_image_api**](docs/MediaApi.md#rescale_image_api) | **GET** /rescale-image | Rescale Image API
*MediaApi* | [**search_icons_api**](docs/MediaApi.md#search_icons_api) | **GET** /search-icons | Search Icons API
*MediaApi* | [**search_royalty_free_images_api**](docs/MediaApi.md#search_royalty_free_images_api) | **GET** /search-images | Search Royalty Free Images API
*MediaApi* | [**vector_search_api**](docs/MediaApi.md#vector_search_api) | **GET** /search-vectors | Vector Search API
*NewsApi* | [**extract_news_api**](docs/NewsApi.md#extract_news_api) | **GET** /extract-news | Extract News API
*NewsApi* | [**search_news_api**](docs/NewsApi.md#search_news_api) | **GET** /search-news | Search News API
*NewsApi* | [**top_news_api**](docs/NewsApi.md#top_news_api) | **GET** /retrieve-top-news | Top News API
*StorageApi* | [**read_key_value_from_store_api**](docs/StorageApi.md#read_key_value_from_store_api) | **GET** /read-key-value | Read Key Value from Store API
*StorageApi* | [**store_key_value_getapi**](docs/StorageApi.md#store_key_value_getapi) | **GET** /store-key-value | Store Key Value (GET) API
*TextApi* | [**correct_spelling_api**](docs/TextApi.md#correct_spelling_api) | **GET** /correct-spelling | Correct Spelling API
*TextApi* | [**detect_gender_by_name_api**](docs/TextApi.md#detect_gender_by_name_api) | **GET** /detect-gender | Detect Gender by Name API
*TextApi* | [**detect_language_api**](docs/TextApi.md#detect_language_api) | **GET** /detect-language | Detect Language API
*TextApi* | [**detect_sentiment_api**](docs/TextApi.md#detect_sentiment_api) | **GET** /detect-sentiment | Detect Sentiment API
*TextApi* | [**extract_dates_api**](docs/TextApi.md#extract_dates_api) | **GET** /extract-dates | Extract Dates API
*TextApi* | [**extract_entities_api**](docs/TextApi.md#extract_entities_api) | **GET** /extract-entities | Extract Entities API
*TextApi* | [**list_word_synonyms_api**](docs/TextApi.md#list_word_synonyms_api) | **GET** /list-synonyms | List Word Synonyms API
*TextApi* | [**pluralize_word_api**](docs/TextApi.md#pluralize_word_api) | **GET** /pluralize-word | Pluralize Word API
*TextApi* | [**score_readability_api**](docs/TextApi.md#score_readability_api) | **GET** /score-readability | Score Readability API
*TextApi* | [**score_text_api**](docs/TextApi.md#score_text_api) | **GET** /score-text | Score Text API
*TextApi* | [**singularize_word_api**](docs/TextApi.md#singularize_word_api) | **GET** /singularize-word | Singularize Word API
*TextApi* | [**stem_text_api**](docs/TextApi.md#stem_text_api) | **GET** /stem-text | Stem Text API
*TextApi* | [**tag_part_of_speech_api**](docs/TextApi.md#tag_part_of_speech_api) | **GET** /tag-pos | Tag Part of Speech API
*WebApi* | [**extract_authors_api**](docs/WebApi.md#extract_authors_api) | **GET** /extract-authors | Extract Authors API
*WebApi* | [**extract_content_from_a_web_page_api**](docs/WebApi.md#extract_content_from_a_web_page_api) | **GET** /extract-content | Extract Content from a Web Page API
*WebApi* | [**extract_publish_date_api**](docs/WebApi.md#extract_publish_date_api) | **GET** /extract-publish-date | Extract Publish Date API
*WebApi* | [**retrieve_page_rank_api**](docs/WebApi.md#retrieve_page_rank_api) | **GET** /retrieve-page-rank | Retrieve Page Rank API
*WebApi* | [**search_web_api**](docs/WebApi.md#search_web_api) | **GET** /search-web | Search Web API
*WebApi* | [**verify_email_address_api**](docs/WebApi.md#verify_email_address_api) | **GET** /verify-email | Verify Email Address API


## Documentation For Models

 - [ComputeNutritionApi200Response](docs/ComputeNutritionApi200Response.md)
 - [ComputeNutritionApi200ResponseIngredientBreakdownInner](docs/ComputeNutritionApi200ResponseIngredientBreakdownInner.md)
 - [ComputeNutritionApi200ResponseIngredientBreakdownInnerNutrientsInner](docs/ComputeNutritionApi200ResponseIngredientBreakdownInnerNutrientsInner.md)
 - [ConvertUnitsApi200Response](docs/ConvertUnitsApi200Response.md)
 - [CorrectSpellingApi200Response](docs/CorrectSpellingApi200Response.md)
 - [DetectGenderByNameApi200Response](docs/DetectGenderByNameApi200Response.md)
 - [DetectLanguageApi200ResponseInner](docs/DetectLanguageApi200ResponseInner.md)
 - [DetectMainImageColorApi200ResponseInner](docs/DetectMainImageColorApi200ResponseInner.md)
 - [DetectSentimentApi200Response](docs/DetectSentimentApi200Response.md)
 - [DetectSentimentApi200ResponseDocument](docs/DetectSentimentApi200ResponseDocument.md)
 - [DetectSentimentApi200ResponseSentencesInner](docs/DetectSentimentApi200ResponseSentencesInner.md)
 - [ExtractAuthorsApi200Response](docs/ExtractAuthorsApi200Response.md)
 - [ExtractAuthorsApi200ResponseAuthorsInner](docs/ExtractAuthorsApi200ResponseAuthorsInner.md)
 - [ExtractContentFromAWebPageApi200Response](docs/ExtractContentFromAWebPageApi200Response.md)
 - [ExtractDatesApi200Response](docs/ExtractDatesApi200Response.md)
 - [ExtractDatesApi200ResponseDatesInner](docs/ExtractDatesApi200ResponseDatesInner.md)
 - [ExtractEntitiesApi200Response](docs/ExtractEntitiesApi200Response.md)
 - [ExtractEntitiesApi200ResponseEntitiesInner](docs/ExtractEntitiesApi200ResponseEntitiesInner.md)
 - [ExtractNewsApi200Response](docs/ExtractNewsApi200Response.md)
 - [ExtractNewsApi200ResponseImagesInner](docs/ExtractNewsApi200ResponseImagesInner.md)
 - [ExtractNewsApi200ResponseVideosInner](docs/ExtractNewsApi200ResponseVideosInner.md)
 - [ExtractPublishDateApi200Response](docs/ExtractPublishDateApi200Response.md)
 - [FindSimilarBooksApi200Response](docs/FindSimilarBooksApi200Response.md)
 - [GenerateNonsenseWordApi200Response](docs/GenerateNonsenseWordApi200Response.md)
 - [ListWordSynonymsApi200Response](docs/ListWordSynonymsApi200Response.md)
 - [PluralizeWordApi200Response](docs/PluralizeWordApi200Response.md)
 - [RandomMemeApi200Response](docs/RandomMemeApi200Response.md)
 - [RandomPoemApi200Response](docs/RandomPoemApi200Response.md)
 - [RandomQuoteApi200Response](docs/RandomQuoteApi200Response.md)
 - [RandomRiddleApi200Response](docs/RandomRiddleApi200Response.md)
 - [RandomTriviaApi200Response](docs/RandomTriviaApi200Response.md)
 - [ReadKeyValueFromStoreApi200Response](docs/ReadKeyValueFromStoreApi200Response.md)
 - [RetrievePageRankApi200Response](docs/RetrievePageRankApi200Response.md)
 - [RetrieveRecipeInformationApi200Response](docs/RetrieveRecipeInformationApi200Response.md)
 - [RetrieveRecipeInformationApi200ResponseCredits](docs/RetrieveRecipeInformationApi200ResponseCredits.md)
 - [RetrieveRecipeInformationApi200ResponseDietaryProperties](docs/RetrieveRecipeInformationApi200ResponseDietaryProperties.md)
 - [RetrieveRecipeInformationApi200ResponseIngredientsInner](docs/RetrieveRecipeInformationApi200ResponseIngredientsInner.md)
 - [RetrieveRecipeInformationApi200ResponseIngredientsInnerMeasures](docs/RetrieveRecipeInformationApi200ResponseIngredientsInnerMeasures.md)
 - [RetrieveRecipeInformationApi200ResponseInstructionsInner](docs/RetrieveRecipeInformationApi200ResponseInstructionsInner.md)
 - [RetrieveRecipeInformationApi200ResponseInstructionsInnerStepsInner](docs/RetrieveRecipeInformationApi200ResponseInstructionsInnerStepsInner.md)
 - [RetrieveRecipeInformationApi200ResponseNutrition](docs/RetrieveRecipeInformationApi200ResponseNutrition.md)
 - [RetrieveRecipeInformationApi200ResponseNutritionIngredientBreakdownInner](docs/RetrieveRecipeInformationApi200ResponseNutritionIngredientBreakdownInner.md)
 - [RetrieveRecipeInformationApi200ResponseScores](docs/RetrieveRecipeInformationApi200ResponseScores.md)
 - [RetrieveRecipeInformationApi200ResponseTaste](docs/RetrieveRecipeInformationApi200ResponseTaste.md)
 - [RetrieveRecipeInformationApi200ResponseTimes](docs/RetrieveRecipeInformationApi200ResponseTimes.md)
 - [ScoreReadabilityApi200Response](docs/ScoreReadabilityApi200Response.md)
 - [ScoreTextApi200Response](docs/ScoreTextApi200Response.md)
 - [ScoreTextApi200ResponseInterestingness](docs/ScoreTextApi200ResponseInterestingness.md)
 - [ScoreTextApi200ResponseInterestingnessSubscores](docs/ScoreTextApi200ResponseInterestingnessSubscores.md)
 - [ScoreTextApi200ResponseReadability](docs/ScoreTextApi200ResponseReadability.md)
 - [ScoreTextApi200ResponseReadabilityMainscores](docs/ScoreTextApi200ResponseReadabilityMainscores.md)
 - [ScoreTextApi200ResponseReadabilitySubscores](docs/ScoreTextApi200ResponseReadabilitySubscores.md)
 - [ScoreTextApi200ResponseSkimmability](docs/ScoreTextApi200ResponseSkimmability.md)
 - [ScoreTextApi200ResponseSkimmabilityMainscores](docs/ScoreTextApi200ResponseSkimmabilityMainscores.md)
 - [ScoreTextApi200ResponseSkimmabilitySubscores](docs/ScoreTextApi200ResponseSkimmabilitySubscores.md)
 - [ScoreTextApi200ResponseStyle](docs/ScoreTextApi200ResponseStyle.md)
 - [ScoreTextApi200ResponseStyleSubscores](docs/ScoreTextApi200ResponseStyleSubscores.md)
 - [SearchBooksApi200Response](docs/SearchBooksApi200Response.md)
 - [SearchBooksApi200ResponseBooksInnerInner](docs/SearchBooksApi200ResponseBooksInnerInner.md)
 - [SearchDrinksApi200Response](docs/SearchDrinksApi200Response.md)
 - [SearchDrinksApi200ResponseDrinksInner](docs/SearchDrinksApi200ResponseDrinksInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerCredits](docs/SearchDrinksApi200ResponseDrinksInnerCredits.md)
 - [SearchDrinksApi200ResponseDrinksInnerIngredientsInner](docs/SearchDrinksApi200ResponseDrinksInnerIngredientsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerIngredientsInnerMeasures](docs/SearchDrinksApi200ResponseDrinksInnerIngredientsInnerMeasures.md)
 - [SearchDrinksApi200ResponseDrinksInnerIngredientsInnerMeasuresMetric](docs/SearchDrinksApi200ResponseDrinksInnerIngredientsInnerMeasuresMetric.md)
 - [SearchDrinksApi200ResponseDrinksInnerIngredientsInnerMeasuresUs](docs/SearchDrinksApi200ResponseDrinksInnerIngredientsInnerMeasuresUs.md)
 - [SearchDrinksApi200ResponseDrinksInnerInstructionsInner](docs/SearchDrinksApi200ResponseDrinksInnerInstructionsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerInstructionsInnerStepsInner](docs/SearchDrinksApi200ResponseDrinksInnerInstructionsInnerStepsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerInstructionsInnerStepsInnerIngredientsInner](docs/SearchDrinksApi200ResponseDrinksInnerInstructionsInnerStepsInnerIngredientsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutrition](docs/SearchDrinksApi200ResponseDrinksInnerNutrition.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutritionCaloricBreakdown](docs/SearchDrinksApi200ResponseDrinksInnerNutritionCaloricBreakdown.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutritionFlavonoidsInner](docs/SearchDrinksApi200ResponseDrinksInnerNutritionFlavonoidsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutritionIngredientBreakdownInner](docs/SearchDrinksApi200ResponseDrinksInnerNutritionIngredientBreakdownInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutritionIngredientBreakdownInnerNutrientsInner](docs/SearchDrinksApi200ResponseDrinksInnerNutritionIngredientBreakdownInnerNutrientsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutritionNutrientsInner](docs/SearchDrinksApi200ResponseDrinksInnerNutritionNutrientsInner.md)
 - [SearchDrinksApi200ResponseDrinksInnerNutritionWeightPerServing](docs/SearchDrinksApi200ResponseDrinksInnerNutritionWeightPerServing.md)
 - [SearchGifsApi200Response](docs/SearchGifsApi200Response.md)
 - [SearchGifsApi200ResponseImagesInner](docs/SearchGifsApi200ResponseImagesInner.md)
 - [SearchIconsApi200Response](docs/SearchIconsApi200Response.md)
 - [SearchJokesApi200Response](docs/SearchJokesApi200Response.md)
 - [SearchJokesApi200ResponseJokesInner](docs/SearchJokesApi200ResponseJokesInner.md)
 - [SearchMemesApi200Response](docs/SearchMemesApi200Response.md)
 - [SearchMemesApi200ResponseMemesInner](docs/SearchMemesApi200ResponseMemesInner.md)
 - [SearchNewsApi200Response](docs/SearchNewsApi200Response.md)
 - [SearchNewsApi200ResponseNewsInner](docs/SearchNewsApi200ResponseNewsInner.md)
 - [SearchRecipesApi200Response](docs/SearchRecipesApi200Response.md)
 - [SearchRecipesApi200ResponseRecipesInner](docs/SearchRecipesApi200ResponseRecipesInner.md)
 - [SearchRecipesApi200ResponseRecipesInnerNutrition](docs/SearchRecipesApi200ResponseRecipesInnerNutrition.md)
 - [SearchRecipesApi200ResponseRecipesInnerNutritionNutrientsInner](docs/SearchRecipesApi200ResponseRecipesInnerNutritionNutrientsInner.md)
 - [SearchRestaurantsApi200Response](docs/SearchRestaurantsApi200Response.md)
 - [SearchRestaurantsApi200ResponseRestaurantsInner](docs/SearchRestaurantsApi200ResponseRestaurantsInner.md)
 - [SearchRestaurantsApi200ResponseRestaurantsInnerAddress](docs/SearchRestaurantsApi200ResponseRestaurantsInnerAddress.md)
 - [SearchRestaurantsApi200ResponseRestaurantsInnerLocalHours](docs/SearchRestaurantsApi200ResponseRestaurantsInnerLocalHours.md)
 - [SearchRestaurantsApi200ResponseRestaurantsInnerLocalHoursOperational](docs/SearchRestaurantsApi200ResponseRestaurantsInnerLocalHoursOperational.md)
 - [SearchRoyaltyFreeImagesApi200Response](docs/SearchRoyaltyFreeImagesApi200Response.md)
 - [SearchRoyaltyFreeImagesApi200ResponseImagesInner](docs/SearchRoyaltyFreeImagesApi200ResponseImagesInner.md)
 - [SearchRoyaltyFreeImagesApi200ResponseImagesInnerLicense](docs/SearchRoyaltyFreeImagesApi200ResponseImagesInnerLicense.md)
 - [SearchWebApi200Response](docs/SearchWebApi200Response.md)
 - [SearchWebApi200ResponseResultsInner](docs/SearchWebApi200ResponseResultsInner.md)
 - [SingularizeWordApi200Response](docs/SingularizeWordApi200Response.md)
 - [StemTextApi200Response](docs/StemTextApi200Response.md)
 - [StoreKeyValueGetapi200Response](docs/StoreKeyValueGetapi200Response.md)
 - [TagPartOfSpeechApi200Response](docs/TagPartOfSpeechApi200Response.md)
 - [TopNewsApi200Response](docs/TopNewsApi200Response.md)
 - [TopNewsApi200ResponseTopNewsInner](docs/TopNewsApi200ResponseTopNewsInner.md)
 - [TopNewsApi200ResponseTopNewsInnerNewsInner](docs/TopNewsApi200ResponseTopNewsInnerNewsInner.md)
 - [VectorSearchApi200Response](docs/VectorSearchApi200Response.md)
 - [VectorSearchApi200ResponseVectorsInner](docs/VectorSearchApi200ResponseVectorsInner.md)
 - [VerifyEmailAddressApi200Response](docs/VerifyEmailAddressApi200Response.md)


To get access to the crate's generated documentation, use:

```
cargo doc --open
```

## Author

mail@apileague.com

